/* ﭮ ᠭ 10a .99 ਭ (514/22) */
/*  N 3 () */

#include <stdio.h>

#define MAX_COL	100
#define MAX_N   200
#define MAX_XY	1000
#define F_OUT	"output.txt"

typedef struct box_t
{
	float x1, y1, x2, y2;
	int c;
	float sq;
} box_t;

int main(int argc, char **argv)
{
	FILE *f;
	int n, i, j;
	float csq[MAX_COL], t;
	char f_in[20];
	box_t b[MAX_N+1];

	scanf("%s", f_in);

	f = fopen(f_in, "r");

	if (!f)
	{
		fprintf(stderr, "Open error\n");
		return (-1);
	}

	b[0].x1 = b[0].y1 = 0.0f;

	if (fscanf(f, "%f %f %d", &b[0].x2, &b[0].y2, &b[0].c) != 3 ||
	    b[0].x2 <= 0 || b[0].x2 > MAX_XY || b[0].y2 <= 0 || b[0].y2 > MAX_XY ||
	    b[0].c <= 0 || b[0].c > MAX_COL)
	{
		fprintf(stderr, "Input error\n");
		fclose(f);
		return (-1);
	}

	b[0].c--;
	b[0].sq = b[0].x2 * b[0].y2;

	if (fscanf(f, "%d", &n) != 1 || n < 0 || n > MAX_N)
	{
		fprintf(stderr, "Input error\n");
		fclose(f);
		return (-1);
	}

	for (i = 0; i < MAX_COL; i++)
		csq[i] = 0;

	for (i = 1; i <= n; i++)
	{
		if (fscanf(f, "%f %f %f %f %d", &b[i].x1, &b[i].y1, &b[i].x2, &b[i].y2, &b[i].c) != 5 ||
		    b[i].x1 < 0 || b[i].x1 > b[0].x2 || b[i].y1 < 0 || b[i].y1 > b[0].y2 ||
		    b[i].x2 < 0 || b[i].x2 > b[0].x2 || b[i].y2 < 0 || b[i].y2 > b[0].y2 ||
		    b[i].c < 1 || b[i].c > MAX_COL)
		{
			fprintf(stderr, "Input error\n");
			fclose(f);
			return (-1);
		}

		if (b[i].x2 < b[i].x1)
		{
			t = b[i].x1;
			b[i].x1 = b[i].x2;
			b[i].x2 = t;
		}
		if (b[i].y2 < b[i].y1)
		{
			t = b[i].y1;
			b[i].y1 = b[i].y2;
			b[i].y2 = t;
		}

		b[i].c--;

		b[i].sq = (b[i].x2 - b[i].x1) * (b[i].y2 - b[i].y1);

		for (j = i-1; j >= 0; j--)
		{
			if (b[i].x1 >= b[j].x1 && b[i].x1 <= b[j].x2 &&
			    b[i].y1 >= b[j].y1 && b[i].y1 <= b[j].y2)
			{
				b[j].sq -= b[i].sq;
				break;
			}
		}
	}

	fclose(f);

	for (i = 0; i <= n; i++)
	{
		csq[b[i].c] += b[i].sq;
	}

	f = fopen(F_OUT, "w");

	for (i = 0; i < MAX_COL; i++)
	{
		if (csq[i] > 0)
		{
			fprintf(f, "%d %.2f\n", i + 1, csq[i]);
		}
	}

	fclose(f);

	return 0;
}
